#include <conio.h>
#include <stdio.h>
#include <io.h>
#include <process.h>
#include <alloc.h>
#include <stdlib.h>
#include <math.h>

void main(int argc, char **argv)
{
  void showchar(int ,int,char *);
  void rchar1(char *,char *,int,int);
  void rchar2(char *,char *,int,int);

  FILE    *fntfile;
  int      xdim,ydim,foffs,fntmode;
  char    *dots,*buff,onechar[1];
  int      i,j,k,l,lastkey,isshow,xcur,ycur,isnew;
  long     fillen,curpos;


  if (argc<4)
    {
     printf("%s\n","Too few parameters.");
     exit(0);
    }

  isnew=0;

  if ((fntfile=fopen(argv[1],"r+b"))==NULL)
    {
     printf("%s\n","File not found.");
     printf("%s\n","Trying to generate new file.");
     isnew=1;
    }

  xdim=atoi(argv[2]);
  ydim=atoi(argv[3]);

  if ((xdim>40) || (ydim>24))
    {
     printf("%s\n","Wrong value of dimension.");
     exit(0);
    }

  dots=(char *)malloc(xdim*ydim);
  buff=(char *)malloc(xdim*ydim/8);

  if (isnew==1)
    if ((fntfile=fopen(argv[1],"w+b"))!=NULL)
      {
       onechar[1]='0';
       for (i=0; i<xdim*ydim*32; i++)
         fwrite(&onechar[1],1,1,fntfile);
       fseek(fntfile,0L,SEEK_SET);
      }
    else
      exit(0);

  curpos=ftell(fntfile);
  fseek(fntfile,0L,SEEK_END);
  fillen=ftell(fntfile);
  fseek(fntfile,curpos,SEEK_SET);

  if (argc>4)
    {
     foffs=atoi(argv[4]);
     if (foffs > fillen)
       foffs=1;
     else
       fseek(fntfile,atol(argv[4]),SEEK_SET);
    }


  for (j=0; j<ydim; j++)
    {
     for (i=0; i<xdim; i++)
       dots[xdim*j+i]='';
    }

  fread(buff,ydim*xdim/8,1,fntfile);
  rchar1(buff,dots,xdim,ydim);

  clrscr();

  gotoxy(48,3);
  printf("PgDn  - next char");

  gotoxy(48,4);
  printf("PgUp  - previous char");

  gotoxy(48,5);
  printf("+     - 1 byte shift forward");

  gotoxy(48,6);
  printf("-     - 1 byte shift backward");

  gotoxy(48,7);
  printf("F3    - save current char");

  gotoxy(48,8);
  printf("Space - inverse current bit");

  gotoxy(48,9);
  printf("Tab   - vertical/horizontal read");
  gotoxy(48,10);
  printf("        <24-pins printer fonts>");

  showchar(xdim,ydim,dots);
  gotoxy(1,1);
  xcur=1;ycur=1;fntmode=1;
  lastkey=0;

  while (lastkey != 27)
    {
     lastkey=getch();
     isshow=0;

     switch (lastkey)
       {
        case  0:
          {
           lastkey=getch();
           switch (lastkey)
             {
              case 145:             // Ctrl/Dn
                {
                 if (dots[(ycur-1)*xdim+xcur-1]=='')
                   dots[(ycur-1)*xdim+xcur-1]=2;
                 else
                   dots[(ycur-1)*xdim+xcur-1]='';

                 printf("%c",dots[(ycur-1)*xdim+xcur-1]);

                 if (ycur==ydim)
                   ycur=1;
                 else
                   ycur++;

                 isshow=1;
                 break;
                }
              case 141:             // Ctrl/Up
                {
                 if (dots[(ycur-1)*xdim+xcur-1]=='')
                   dots[(ycur-1)*xdim+xcur-1]=2;
                 else
                   dots[(ycur-1)*xdim+xcur-1]='';

                 printf("%c",dots[(ycur-1)*xdim+xcur-1]);

                 if (ycur==1)
                   ycur=ydim;
                 else
                   ycur--;

                 isshow=1;
                 break;
                }
              case 116:             // Ctrl/Rt
                {
                 if (dots[(ycur-1)*xdim+xcur-1]=='')
                   dots[(ycur-1)*xdim+xcur-1]=2;
                 else
                   dots[(ycur-1)*xdim+xcur-1]='';

                 printf("%c",dots[(ycur-1)*xdim+xcur-1]);

                 if (xcur==xdim)
                   xcur=1;
                 else
                   xcur++;

                 isshow=1;
                 break;
                }
              case 115:             // Ctrl/Lt
                {
                 if (dots[(ycur-1)*xdim+xcur-1]=='')
                   dots[(ycur-1)*xdim+xcur-1]=2;
                 else
                   dots[(ycur-1)*xdim+xcur-1]='';

                 printf("%c",dots[(ycur-1)*xdim+xcur-1]);

                 if (xcur==1)
                   xcur=xdim;
                 else
                   xcur--;

                 isshow=1;
                 break;
                }
              case 80:              // Dn
                {
                 if (++ycur>ydim)
                   ycur=1;
                 break;
                }
              case 72:              // Up
                {
                 if (--ycur<1)
                   ycur=ydim;
                 break;
                }
              case 77:              // Rt
                {
                 if (++xcur>xdim)
                   xcur=1;
                 break;
                }
              case 75:              // Lt
                {
                 if (--xcur<1)
                   xcur=xdim;
                 break;
                }
              case 81:              // PgDn
                {
                 if (ftell(fntfile)+ydim*xdim/8<=fillen)
                   {
                    fread(buff,ydim*xdim/8,1,fntfile);
                    if (fntmode==1)
                      rchar1(buff,dots,xdim,ydim);
                    else
                      rchar2(buff,dots,xdim,ydim);
                    showchar(xdim,ydim,dots);
                   }
                 break;
                }
              case 73:              // PgUp
                {
                 if (ftell(fntfile)-ydim*xdim/4>=0)
                   {
                    fseek(fntfile,-ydim*xdim/4L,SEEK_CUR);
                    fread(buff,ydim*xdim/8,1,fntfile);
                    if (fntmode==1)
                      rchar1(buff,dots,xdim,ydim);
                    else
                      rchar2(buff,dots,xdim,ydim);
                    showchar(xdim,ydim,dots);
                   }
                 break;
                }
              case 61:
                {
                 fseek(fntfile,-ydim*xdim/8L,SEEK_CUR);
                 if (fntmode==1)
                   {
                    for (i=0; i<ydim*xdim/8; i++)
                      {
                       j=0;
                       for (k=0; k<8; k++)
                         {
                          if (dots[i*8+k]==2)
                           j=j+(0x80>>k);
                         }
                       buff[i]=j;
                      }
                   }
                 else
                   {
                    for (j=0; j<xdim; j++)
                      {
                       for (i=0; i<ydim/8; i++)
                         {
                          k=0;
                          for (l=0; l<8; l++)
                            {
                             if (dots[(i*8+l)*xdim+j]==2)
                               k=k+(0x80>>l);
                            }
                          buff[i+j*ydim/8]=k;
                         }
                      }
                   }
                }
                fwrite(buff,1,ydim*xdim/8,fntfile);
                fseek(fntfile,0L,SEEK_CUR);
                break;
             }
           gotoxy(xcur,ycur);
           break;
          }
        case 32:
          {
           if (dots[(ycur-1)*xdim+xcur-1]=='')
             dots[(ycur-1)*xdim+xcur-1]=2;
           else
             dots[(ycur-1)*xdim+xcur-1]='';
           isshow=1;
           printf("%c",dots[(ycur-1)*xdim+xcur-1]);
           break;
          }
        case 43:                        // GrayPlus
          {
           if (ftell(fntfile) < fillen)
             {
              fseek(fntfile,-ydim*xdim/8L+1,SEEK_CUR);
              fread(buff,ydim*xdim/8,1,fntfile);
              if (fntmode==1)
                rchar1(buff,dots,xdim,ydim);
              else
                rchar2(buff,dots,xdim,ydim);
              showchar(xdim,ydim,dots);
              gotoxy(xcur,ycur);
             }
           break;
          }
        case 45:                        // GrayMinus
          {
           if (ftell(fntfile) > 0)
             {
              fseek(fntfile,-ydim*xdim/8L-1,SEEK_CUR);
              fread(buff,ydim*xdim/8,1,fntfile);
              if (fntmode==1)
                rchar1(buff,dots,xdim,ydim);
              else
                rchar2(buff,dots,xdim,ydim);
              showchar(xdim,ydim,dots);
              gotoxy(xcur,ycur);
             }
           break;
          }
        case  9:
          {
           if (fmod(ydim,8)==0)
             {
              if (fntmode==1)
                fntmode=2;
              else
                fntmode=1;
             }
           break;
          }
       }

     if (isshow==1)
       {
        gotoxy(xcur,ycur);
       }
    }

  clrscr();
  fclose(fntfile);
  printf("%s\n","Matrix fonts editor V1.01.");
  printf("%s\n","Copyright (C) by Andrey Stepanov.");
  printf("%s\n","Pskov, 1992.");
}



void showchar(int xcrd,int ycrd, char *fly)
{
  int i,j;

  gotoxy(1,1);

  for (j=0; j<ycrd; j++)
    {
     for (i=0; i<xcrd; i++)
       {
        printf("%c",fly[xcrd*j+i]);
       }
     printf("\n");
    }
}


void rchar1(char *tbuff,char *fly,int xmax,int ymax)
{
 int i,k;

 for (i=0; i<ymax*xmax/8; i++)
   for (k=0; k<8; k++)
     if ((tbuff[i] & (0x80>>k))==(0x80>>k))
       fly[i*8+k]=2;
     else
       fly[i*8+k]='';
}

void rchar2(char *tbuff,char *fly,int xmax,int ymax)
{
  int i,j,k;

  for (j=0; j<xmax; j++)
    for (i=0; i<ymax/8; i++)
      for (k=0; k<8; k++)
        if ((tbuff[i+j*ymax/8] & (128>>k))==(128>>k))
          fly[(i*8+k)*xmax+j]=2;
        else
          fly[(i*8+k)*xmax+j]='';
}
